package com.cmx.wanhui.retrofit

import com.google.gson.reflect.TypeToken
import okhttp3.ResponseBody
import org.json.JSONException
import org.json.JSONObject
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import java.io.IOException

class ApiRequtest<T>(
    call: Call<ResponseBody?>,
    private val mResultType: TypeToken<T>,
    listener: ApiResponse.Listener<ApiResult<T>?>,
    errorListener: ApiResponse.ErrorListener
) {
    init {
        call.enqueue(object : Callback<ResponseBody?> {
            override fun onResponse(call: Call<ResponseBody?>, response: Response<ResponseBody?>) {
                try {
                    val responseBody = response.body()
                    if (responseBody != null) {
                        val jsonString = response.body()!!.string()
                        val result = ApiResult(JSONObject(jsonString), mResultType)
                        listener.onResponse(result)
                    }
                } catch (e: IOException) {
                } catch (e: JSONException) {
                }
            }

            override fun onFailure(call: Call<ResponseBody?>, t: Throwable) {
                errorListener.onErrorResponse(t)
            }
        })
    }

    companion object {
        private val TAG = ApiRequtest::class.java.simpleName
    }
}