package com.cmx.wanhui.retrofit

import com.google.gson.Gson
import com.google.gson.reflect.TypeToken
import org.json.JSONObject

/**
 *
 */
class ApiResult<T> {
    var success = true
    var code = OK
    var msg = ""
    var result: T? = null
        private set
    val msgJson: String? = null

    constructor() : super() {        // TODO Auto-generated constructor stub
    }

    constructor(jsonObject: JSONObject, typeToken: TypeToken<T>) : super() {
        try {
            if (jsonObject.has("errcode")) {
                code = jsonObject.getInt("errcode")
                if (code != OK) {
                    if (jsonObject.has("errmsg")) {
                        msg = jsonObject.getString("errmsg")
                    }
                    success = false
                }
            } else {
            }
            if (code == OK) {
                try {
                    result = gson.fromJson(jsonObject.toString(), typeToken.type)
                } catch (ex: Exception) {
                }
            }
        } catch (e: Exception) {
            // TODO: handle exception
        }
    }

    private fun testDefault(msg: String): T? {
        val gson = Gson()
        result = gson.fromJson(msg, object : TypeToken<T>() {}.type)
        return result
    }

    private fun test(msg: String, typeToken: TypeToken<T>): T? {
        val gson = Gson()
        result = gson.fromJson(msg, typeToken.type)
        return result
    }

    fun setResult(result: T) {
        this.result = result
    }

    companion object {
        private val TAG = ApiResult::class.java.simpleName
        const val OK = 0
        private val gson = Gson()
    }
}