package com.cmx.wanhui.ui

import android.graphics.Bitmap
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.webkit.WebResourceError
import android.webkit.WebResourceRequest
import android.webkit.WebSettings
import android.webkit.WebView
import android.webkit.WebViewClient
import androidx.fragment.app.Fragment
import com.cmx.wanhui.utils.AndroidtoJs
import com.cmx.wanhui.utils.MyUtils
import com.cmx.wanhui.view.BaseLoadingDialog
import com.lsxiao.apollo.core.Apollo
import com.lsxiao.apollo.core.contract.ApolloBinder

open class BaseFragment : Fragment() {

    var mBaseLoadingDialog: BaseLoadingDialog? = null
    var mApolloBinder: ApolloBinder? = null


    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return inflater.inflate(null, container, false)
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        requireActivity().window.decorView.systemUiVisibility = View.SYSTEM_UI_FLAG_LIGHT_STATUS_BAR
        mBaseLoadingDialog = BaseLoadingDialog(activity)
        mApolloBinder = Apollo.bind(this)
    }


    /**
     * 相关属性设置
     */
    fun setWebView(webView: WebView) {
        val webSettings = webView.settings
        webSettings.javaScriptEnabled = true
        webSettings.cacheMode = WebSettings.LOAD_NO_CACHE
        webSettings.domStorageEnabled = true
        webSettings.allowFileAccess = true //文件访问
        webSettings.allowFileAccessFromFileURLs = true
        webView.addJavascriptInterface(AndroidtoJs(), "AndroidtoJs")
        webView.webViewClient = object : WebViewClient() {
            override fun onPageStarted(view: WebView?, url: String?, favicon: Bitmap?) {
                super.onPageStarted(view, url, favicon)
                showDialog()
            }

            override fun shouldOverrideUrlLoading(view: WebView, url: String): Boolean {
                view.loadUrl(url)
                return true
            }

            override fun onPageFinished(view: WebView, url: String) {
                disDialog()
            }

            override fun onReceivedError(view: WebView, request: WebResourceRequest, error: WebResourceError) {
                disDialog()
            }
        }
    }


    override fun onDestroyView() {
        super.onDestroyView()
        if (mApolloBinder != null) {
            mApolloBinder!!.unbind()
        }
    }

    fun showDialog() {
        mBaseLoadingDialog = BaseLoadingDialog(activity)
        if (!mBaseLoadingDialog!!.isShowing) {
            mBaseLoadingDialog!!.show()
        }
    }

    fun disDialog() {
        if (mBaseLoadingDialog!!.isShowing) {
            mBaseLoadingDialog!!.dismiss()
        }
    }

}