package com.cmx.wanhui.utils

import android.content.pm.PackageManager
import android.util.Log
import android.webkit.JavascriptInterface
import com.cmx.wanhui.activity.MyApplication.Companion.getmInstance
import com.cmx.wanhui.constant.Events
import com.lsxiao.apollo.core.Apollo

class AndroidtoJs {
    // 定义JS需要调用的方法
    // 被JS调用的方法必须加入@JavascriptInterface注解
    @JavascriptInterface
    fun getAppToken(): String? {
        L.e("JS--", "getAppToken()")
        return SpUtils.getString(getmInstance()!!, "token")
    }

    /**
     * 用户角色类型
     *
     * @return
     */
    @JavascriptInterface
    fun getUser(): String? {
        L.e("JS--", "getUser()")
        return SpUtils.getString(getmInstance()!!, "admin")
    }

    //版本号
    @JavascriptInterface
    fun getAppVersion(): String {
        L.e("JS--", "getAppVersion()")
        val versionname: String //版本号
        versionname = try {
            val pm = getmInstance()!!.applicationContext.packageManager
            val pi = pm.getPackageInfo(getmInstance()!!.applicationContext.packageName, 0)
            "V" + pi.versionName
        } catch (e: PackageManager.NameNotFoundException) {
            "未知"
        }
        return versionname
    }

    @JavascriptInterface
    fun existApp() {
        L.e("JS--", "existApp()")
        Apollo.emit(Events.JS_OPEN_LOGOUT)
    }

    @JavascriptInterface
    fun showTab() { //tabbar显示
        L.e("JS--", "showTab()")
        Apollo.emit(Events.JS_OPEN_TABBAR_SHOW)
    }

    @JavascriptInterface
    fun hideTab() { //tabbar隐藏
        L.e("JS--", "hideTab()")
        Apollo.emit(Events.JS_OPEN_TABBAR_HIDE)
    }

    @JavascriptInterface
    fun openWeb(url: String) { //打开一个新的web界面
        L.e("JS--", "openWeb()$url")
        Apollo.emit(Events.JS_OPEN_OPEN_WEB, url)
    }

    @JavascriptInterface
    fun closeWeb() { //关闭那个新的web界面
        L.e("JS--", "closeWeb()")
        Apollo.emit(Events.JS_OPEN_CLOSE_WEB)
    }

    @JavascriptInterface
    fun checkTab(mode: String?) { //关闭注册/忘记密码
        L.e("JS--", "checkTab()")
        Apollo.emit(Events.JS_OPEN_TAB, mode!!)
    }

    @JavascriptInterface
    fun scanQR() { //扫描二维码
        L.e("JS--", "scanQR()")
        Apollo.emit(Events.JS_OPEN_SCANQR)
    }

    companion object {
        private const val TAG = "cmx_AndroidtoJs"
    }
}