package com.cmx.wanhui.view;

import android.app.Dialog;
import android.content.Context;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;

import com.cmx.wanhui.R;


/**
 * 确认弹窗
 */
public class ConfirmDialog extends Dialog {

    private TextView mConfirm;
    private TextView mCancel;
    private IBack mIBack;


    public ConfirmDialog(Context context, IBack mIBack) {
        super(context, R.style.CustomDialog);
        this.mIBack = mIBack;
    }


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.dialog_confirm_all);
        setCancelable(false);
        setCanceledOnTouchOutside(false);
        mConfirm = findViewById(R.id.con_con);
        mCancel = findViewById(R.id.con_cancel);
        mConfirm.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                mIBack.confirmBack();
                dismiss();

            }
        });
        mCancel.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                mIBack.cancelBack();
                dismiss();
            }
        });
    }

    public interface IBack {
        void confirmBack();

        void cancelBack();
    }

}